
/******************************************************************************
*
* Freescale Semiconductor Inc.
* (c) Copyright 2011-2012 Freescale Semiconductor, Inc.
* ALL RIGHTS RESERVED.
*
*******************************************************************************
*
* @file Blink_use_bootloader.c
*
* @author a13984
*
* @version 0.0.1
*
* @date Jul-15-2011
*
* @brief providing framework of test cases for MCU. 
*
*******************************************************************************/

#include "common.h"
#include "rtc.h"
#include "pit.h"

/******************************************************************************
* Global variables
******************************************************************************/

/******************************************************************************
* Constants and macros
******************************************************************************/

/******************************************************************************
* Local types
******************************************************************************/

/******************************************************************************
* Local function prototypes
******************************************************************************/

/******************************************************************************
* Local variables
******************************************************************************/

/******************************************************************************
* Local functions
******************************************************************************/
int main (void);
void RTC_Task(void);
void PIT0_CallBack( void );

/******************************************************************************
* Global functions
******************************************************************************/


/********************************************************************/
int main (void)
{
	char ch;     
    uint32_t i;
  	printf("\nRunning the Blink_use_bootloader project.\n");
    LED0_Init();  
    LED2_Init();
    RTC_SetupTimerCallback(RTC_Task);
    RTC_Init(RTC_CLKSRC_1KHZ,3, RTC_CLK_PRESCALER_100);
	PIT_Init(0,0xffffff);
    PIT_SetupCallBack(PIT0_CallBack);
    while(1)
	{
       // LED0_Toggle();
        for(i=0;i<0xfffff;i++);
	} 
}

/*****************************************************************************//*!
+FUNCTION----------------------------------------------------------------
* @function name: RTC_Task
*
* @brief callback routine of RTC driver which does what you want to do at 
*        every RTC period.
*        
* @param  none
*
* @return none
*
* @ Pass/ Fail criteria: none
*****************************************************************************/

void RTC_Task(void)
{
    /* toggle LED1 */
   LED0_Toggle(); 
}
/********************************************************************/

void PIT0_CallBack( void )
{
    
   LED2_Toggle();
}
